'use strict';

exports.__esModule = true;
exports.getFieldName = undefined;

var _startCase = require('lodash/startCase');

var _startCase2 = _interopRequireDefault(_startCase);

var _validate = require('validate.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getFieldName = exports.getFieldName = function getFieldName(_ref) {
  var target = _ref.target,
      lang = _ref.lang,
      itemKey = _ref.itemKey,
      dashboardList = _ref.dashboardList,
      _ref$dashboardDoc = _ref.dashboardDoc,
      dashboardDoc = _ref$dashboardDoc === undefined ? {} : _ref$dashboardDoc,
      _ref$dashboard = _ref.dashboard,
      dashboard = _ref$dashboard === undefined ? {} : _ref$dashboard,
      _ref$dashboardConfig = _ref.dashboardConfig,
      dashboardConfig = _ref$dashboardConfig === undefined ? {} : _ref$dashboardConfig;

  var i18n = (0, _validate.getDeepObjectValue)(dashboardConfig, 'i18n.' + lang + '.fields.' + itemKey);
  if (i18n) return i18n;
  if (target === 'filters') {
    return (0, _startCase2.default)(itemKey);
  } else if (target === 'doc') {
    return dashboardDoc.label || dashboard.label || (0, _startCase2.default)(itemKey);
  } else if (target === 'list') {
    return dashboardList.label || dashboard.label || (0, _startCase2.default)(itemKey);
  } else {
    throw new Error('getFieldName first argument must be list or doc');
  }
};